Subject: Re: issue with git submodules and a clone.defaultRemoteName different than origin?

From: Patrick Steinhardt <[email-masked]>
Date: Sat, 7 Jun 2025 07:43:36 +0200

On Fri, Jun 06, 2025 at 04:32:21PM -0700, Junio C Hamano wrote:
> Jacob Keller <[email-masked]> writes:
> 
> > It looks like those end up in the "read_remotes_file" and
> > "read_branches_file" functions which are deprecated, and planned to be
> > removed in 3.0...
> >
> > Would patches to modify those to take a repository pointer in order to
> > allow callers of read_config() to work properly with a submodule
> > repository be acceptable?
> 
> The recent trend has been that it generally is very much welcomed to
> fix such a code path that takes "repo" at an entry point but ends up
> deep in its callchain to ignore it and use the_repository instead,
> even without a potential use case to benefit from such a change.
> 
> You have a concrete use case, so I would suspect it is even better
> than "acceptable".  Patrick, what do you think?

I definitely agree, yes. It is a long road to get rid of
`the_repository`. Taking many small steps on this road that have a
proper motivation is way easier than doing large steps that get rid of
the variable for the sake of getting rid of it.

Patrick